<?php



class DbConnect {
	
	public $handle = NULL;
	public $dataSource = NULL;
	
	static protected $defaultDBconnection = NULL;
	
	function __construct($dataSrc = NULL, $accountID = NULL, $password = NULL, $hostName = NULL) {
		
		// If no parameters are passed, then use our default database parameters from our constants file.
		if ($dataSrc == NULL) {
			$dataSrc = Constants::getDatabaseName();
			$hostName = Constants::getDatabaseHost();
			$accountID = Constants::getDatabaseAccountID();
			$password = Constants::getDatabasePassword();
		}
		
		$this->handle = mysql_connect( $hostName, $accountID, $password );
		if(!$this->handle){
			throw new Exception("Error: Unable to connect to database." );
		}
		
		mysql_select_db( $dataSrc, $this->handle );
		
		$this->dataSource = $dataSrc;
	}
	
	function __destruct(){
		if($this->handle){
			mysql_close($this->handle);
		}
	}
	
	// Kind of like a Singleton, returns the a default database connection.
	static function getDefaultConnection(){
		
		if(self::$defaultDBconnection === NULL){
			self::$defaultDBconnection = new DbConnect();
		}
		
		return self::$defaultDBconnection;
	}

}


