<?php

 
// Automatically load Classes if the FileName matches the class Name.
function __autoload($class_name) {
	
	//class directories
	$directories = array (
		'',
		'Classes/',
		'Classes/Neurons/',
		'Classes/Neurons/Gender/',
		'Classes/Relationships/'
	);
	
	// For each directory... try and include the file.
	foreach ( $directories as $directory ) {

		if (file_exists ( $directory . $class_name . '.php' )) {
			require_once ($directory . $class_name . '.php');
			return;
		}
		else if (file_exists ( $directory . $class_name . '.inc' )) {
			require_once ($directory . $class_name . '.inc');
			return;
		}
	}
}

